

void create_leonie_cfg (void)
{
  int rank_in_my_subobj;
  int my_subobj_size;
  char 
  globus_duroc_runtime_intra_subjob_rank(&rank_in_my_subjob);
  globus_duroc_runtime_intra_subjob_size(&my_subjob_size);

  if (rank_in_my_subjob)
    {
      char myipaddr[4];
      char hostname[100];
      struct hostent *h;
      gethostname(hostname,sizeof(hostname));
      h = gethostbyname(hostname);
      if (!h || h->h_length != 4 || h->addr_type != AF_INET) {
	globus_libc_fprintf(stderr, "ERROR: cannot get my IPv4 addr for %s\n",hostname);
	exit(1);
      }
      memcpy(myipaddr,h->h_addr_list[0],4);
      
      char *rbuff;
      char tag[200];
      
      sprintf(tag, "%s%d", SUBJOB_MASTER_TO_SLAVE_T, call_idx);
      
      globus_duroc_runtime_intra_subjob_send(0, "MYIP", 4, myipaddr);

      globus_duroc_runtime_intra_subjob_receive("LEONIEADDR", 4, myipaddr);

    }
  else
    {
	/* subjob master */
	int duroc_subjobmaster_rank;
	int my_subjob_addr;
	int rsl_subjob_rank;
	char *rsl_subjob_rank_env_var;

	globus_duroc_runtime_inter_subjob_structure(&my_subjob_addr,
						    nsubjobs,
						    subjob_addresses);
	/* finding index of master subjob 0, he */
	/* is the one with the lowest address   */
	for (i = 0, sj0_master_idx = -1, duroc_subjobmaster_rank = 0; 
	    i < *nsubjobs; i ++)
	{
	    if ((sj0_master_idx == -1 
		    && (*subjob_addresses)[i] < my_subjob_addr)
	    || (sj0_master_idx != -1 
		    && (*subjob_addresses)[i] 
				< (*subjob_addresses)[sj0_master_idx]))
		sj0_master_idx = i;
	    if ((*subjob_addresses)[i] < my_subjob_addr)
		duroc_subjobmaster_rank ++;
	} /* endfor */
	/* globus_duroc_runtime_inter_subjob_structure reports the */
	/* number of REMOTE subjobs (*other* than the subjob i'm   */
	/* master of).  to get the TOTAL number of subjobs in this */
	/* run i must increment the value reported by              */
	/* globus_duroc_runtime_inter_subjob_structure             */
	(*nsubjobs) ++;

	/* NICK: should not exit here ... should set globus-like rc. */
	if (!(rsl_subjob_rank_env_var=getenv("GLOBUS_DUROC_SUBJOB_INDEX")))
	{
	    globus_libc_fprintf(stderr, 
		"ERROR: required environment variable "
		"GLOBUS_DUROC_SUBJOB_INDEX not set.\n");
	    globus_libc_fprintf(stderr, 
		"       Each subjob in envoking RSL must have "
		"GLOBUS_DUROC_SUBJOB_INDEX\n");
	    globus_libc_fprintf(stderr, 
		"       set to rank (0, 1, 2, ...) of subjob as it "
		"appears in the envoking RSL.\n");
	    exit(1);
	} /* endif */
	rsl_subjob_rank = atoi(rsl_subjob_rank_env_var);
	if (rsl_subjob_rank < 0 || rsl_subjob_rank >= *nsubjobs)
	{
	    globus_libc_fprintf(stderr, 
		"ERROR: env variable GLOBUS_DUROC_SUBJOB_INDEX "
		"%d must be >= 0 and\n", 
		rsl_subjob_rank);
	    globus_libc_fprintf(stderr, 
		"ERROR: less than the number of subjobs %d for this run.\n", 
		*nsubjobs);
	    exit(1);
	} /* endif */

	if (duroc_subjobmaster_rank)
	{
	    /* NOT master of subjob 0 */

	    sprintf(topology_buff,
		    "%d %d %d",
		    duroc_subjobmaster_rank,
		    rsl_subjob_rank,
		    my_subjob_size);

	    {
		char tag[200];

		sprintf(tag, "%s%d", 
		    SUBJOB_MASTER_TO_SUBJOB0_MASTER_T, call_idx);
		globus_duroc_runtime_inter_subjob_send(
		    (*subjob_addresses)[sj0_master_idx], /* dest */
		    tag,                                 /* tag */
		    strlen(topology_buff)+1,             /* nbytes */
		    (globus_byte_t *) topology_buff);    /* data */

		sprintf(tag, "%s%d", 
		    SUBJOB0_MASTER_TO_SUBJOB_MASTER_T, call_idx);
		globus_duroc_runtime_inter_subjob_receive(
		    tag,                       /* tag */
		    &bufflen,                  /* nbytes received? */
		    (globus_byte_t **) &buff); /* message */
	    }

	    sscanf(buff, "%d %d", nprocs, my_grank);

	    globus_libc_free(buff);
	}
	else
	{
	    /* master of subjob 0 */

	    int j;
	    int temp;
	    /* vectors len nsubjobs, all indexed by duroc_subjobmaster_rank */
	    int *rsl_ranks; /* received from other subjob masters */

	    /* NICK: exiting on these failed mallocs is not right thing */
	    /*       to do.  should set error rc and return. fix that   */
	    /*       later when i learn more about globus rc stuff.     */
	    if (!(rsl_ranks = 
		(int *) globus_libc_malloc(*nsubjobs*sizeof(int))))
	    {
		globus_libc_fprintf(stderr, 
		    "ERROR: failed malloc of %ld bytes\n", 
		    *nsubjobs*sizeof(int));
		exit(1);
	    } /* endif */
	    if (!(job_sizes = 
		(int *) globus_libc_malloc(*nsubjobs*sizeof(int))))
	    {
		globus_libc_fprintf(stderr, 
		    "ERROR: failed malloc of %ld bytes\n", 
		    *nsubjobs*sizeof(int));
		exit(1);
	    } /* endif */
	    if (!(g_ranks = (int *) globus_libc_malloc(*nsubjobs*sizeof(int))))
	    {
		globus_libc_fprintf(stderr, 
		    "ERROR: failed malloc of %ld bytes\n", 
		    *nsubjobs*sizeof(int));
		exit(1);
	    } /* endif */

	    /* need to sort subjob_addresses so that i may associate */
	    /* (using incoming duroc_subjobmaster_rank) incoming     */
	    /* rsl_subjob_rank and my_subjob_size with dest addr     */
	    /* in subjob_addresses                                   */
	    for (i = 1; i < *nsubjobs-1; i ++)
	    {
		for (j = i; j > 0; j --)
		{
		    if ((*subjob_addresses)[j] < (*subjob_addresses)[j-1])
		    {
			temp = (*subjob_addresses)[j];
			(*subjob_addresses)[j] = (*subjob_addresses)[j-1];
			(*subjob_addresses)[j-1] = temp;
		    } /* endif */
		} /* endfor */
	    } /* endfor */

	    /* rsl_ranks[] and job_sizes[] are indexed by  */
	    /* duroc_subjobmaster_rank, and i know that my */
	    /* duroc_subjobmaster_rank==0                  */
	    rsl_ranks[0] = rsl_subjob_rank;
	    job_sizes[0] = my_subjob_size;

	    {
		char tag[200];

		sprintf(tag, "%s%d", 
		    SUBJOB_MASTER_TO_SUBJOB0_MASTER_T, call_idx);

		for (i = 1; i < *nsubjobs; i ++)
		{
		    int ranks, sizes;
		    
		    /*
		     * receiving 3 longs from other subjob master
		     *    duroc_subjobmaster_rank (used to index job_sizes[] 
		     *                             and rsl_ranks[])
		     *    rsl_subjob_rank 
		     *    my_subjob_size
		     */

		    globus_duroc_runtime_inter_subjob_receive(
			tag,                       /* tag */
			&bufflen,                  /* nbytes received? */
			(globus_byte_t **) &buff); /* message */

		    sscanf(buff, "%d %d %d", &j, &ranks, &sizes);
		    rsl_ranks[j] = ranks;
		    job_sizes[j] = sizes;
		    
		    globus_libc_free(buff);
		} /* endfor */
	    }

	    /* calculating nprocs and everyones' g_rank based */
	    /* on rsl_rank and job_sizes ...                  */
	    /* mygrank = sum job_size for all rsl_ranks       */
	    /*           that are less than mine              */
	    for (i = 0, *nprocs = 0; i < *nsubjobs; i ++)
	    {
		(*nprocs) += job_sizes[i];
		for (g_ranks[i] = 0, j = 0; j < *nsubjobs; j ++)
		if (rsl_ranks[i] > rsl_ranks[j])
		    g_ranks[i] += job_sizes[j];
	    } /* endfor */
	    *my_grank = g_ranks[0];

	    {
		char tag[200];

		sprintf(tag, "%s%d", 
		    SUBJOB0_MASTER_TO_SUBJOB_MASTER_T, call_idx);

		/* sending other subjob masters nprocs and their g_rank */
		for (i = 0; i < *nsubjobs-1; i ++)
		{
		    sprintf(topology_buff, "%d %d", *nprocs, g_ranks[i+1]);
		    globus_duroc_runtime_inter_subjob_send(
			(*subjob_addresses)[i],           /* dest */
			tag,                              /* tag */
			strlen(topology_buff)+1,          /* nbytes */
			(globus_byte_t *) topology_buff); /* data */
		} /* endfor */
	    }

	    globus_libc_free(rsl_ranks);
	    globus_libc_free(job_sizes);
	    globus_libc_free(g_ranks);

	} /* endif */

	/* all subjob masters sending nprocs and their g_rank to their slaves */
#       if defined(VMPI)
	{
	    int v[2];
	    int rc;

	    v[0] = *nprocs;
	    v[1] = *my_grank;

	    /* MPI_Bcast(v, 2, MPI_INT, 0, MPI_COMM_WORLD); */
	    rc = vmpi_error_to_mpich_error(
		    mp_bootstrap_bcast((void *) v, /* buff */
					2,          /* count */
					0));        /* type, 0 == vMPI_INT */
	    if (rc != MPI_SUCCESS)
	    {
		globus_libc_fprintf(stderr, 
		    "ERROR: get_topology(): erroneous rc = %d from "
		    "mp_bootstrap_bcast (root)\n",
		    rc);
		exit(1);
	    } /* endif */
	}
#       else
        {
	    {
		char tag[200];

		sprintf(tag, "%s%d", SUBJOB_MASTER_TO_SLAVE_T, call_idx);

		for (i = 1; i < my_subjob_size; i ++)
		{
		    sprintf(topology_buff, "%d %d", *nprocs, (*my_grank) + i);
		    intra_subjob_send(i,                     /* dest */
				    tag,                     /* tag */
				    strlen(topology_buff)+1, /* nbytes */
				    topology_buff);          /* data */
		} /* endfor */
	    }
        }
#       endif
