#include <stdio.h> 
#include <stdlib.h> 
#include <string.h>

#include "mpi.h"

#define BUGSIZE (1)		
#define MINSIZE (1)
#define NLOOPS  (1)


int main( int argc, char **argv )
{
  int i,t,k,index ;
  volatile short  j=0;
  int myrank , myrank2 ;
  int mysize , mysize2 ;
  int sizemax = 16 * BUGSIZE  ;
  MPI_Status status;
  char *send;
  char *data; 
  
  MPI_Init(&argc, &argv);
  fprintf(stderr,"Value is %i\n",MPI_COMM_NUMBER );
  
  for (index = 0 ; index < MPI_COMM_NUMBER ; index++)
    {
      if (MPI_USER_COMM[index] != MPI_COMM_NULL)
	{
	  
	  MPI_Comm_rank(MPI_USER_COMM[index], &myrank2);
	  MPI_Comm_size(MPI_USER_COMM[index], &mysize2); 

	  if (MPI_USER_COMM[index] == MPI_COMM_WORLD)
	    {
	       fprintf(stderr,"Hello World from %i in MPI_COMM_WORLD  (User Comm %i )\n",myrank2, index);
	    }
	  else
	    {
	       fprintf(stderr,"Hello World from %i in %i  User Comm \n",myrank2,index);
	    }
	  
	  if(myrank2 == 0)
	    {
	      for (t=0 ; t<mysize2 ; t++)
		{
		  if (t != myrank2)
		    {
		      for( i = MINSIZE ; i < sizemax + 1 ;i += BUGSIZE ) 
			for ( k = 0 ; k < NLOOPS ; k++ )
			  {
			    send = (char *)malloc(i*sizeof(char));
			    MPI_Send(send,i,MPI_CHAR,t,999,MPI_USER_COMM[index]);
			    /*fprintf(stderr,"Sent message of length : %i % i\n",i,k);*/
			    free(send);
			    /*fprintf(stderr," Free Done ... \n");*/
			  }
		      fprintf(stderr,"%i ------> All sent\n", myrank2);   
		    }
		}
	    }
	  else     
	    {
	      for( i = MINSIZE ; i < sizemax + 1 ; i += BUGSIZE )
		{
		  for ( k=0 ; k < NLOOPS ; k++ )
		    {
		      data = (char *)malloc(i*sizeof(char));
		      MPI_Recv(data,i, MPI_CHAR,0,999, MPI_USER_COMM[index],&status);
		      fprintf(stderr,"Received message of length : %i % i\n",i,k);
		      free(data); 
		      //fprintf(stderr," Free Done ... \n");
		    }
		}
	      fprintf(stderr,"%i ------> All get\n", myrank2); 
	    }
	}
    }
  MPI_Finalize();
  return 0;
}
