/*******************************************************************/
#ifndef HAVE_STDLIB_H
extern char *getenv ();
#else
#include <stdlib.h>
#endif
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

#include "hot_stuff.h"
#include "flow.h"
#include <stdio.h>
#include <assert.h>


/***********************************************************************************/
/*                                   VARIABLES                                     */
/***********************************************************************************/
#define FOR_EVER 1

extern int                MPID_MAD_Channel_Number; 
extern int                MPID_MAD_Global_Channel_Number; 
CH_MAD_channel_info_t    *MPID_MAD_Channel_Table;
CH_MAD_channel_info_t    *MPID_MAD_Global_Channel_Table;
p_mad_channel_t          *MPID_MAD_Default_Channel;
MPI_Comm                 *MPI_USER_COMM;   
int                       MPI_COMM_WORLD_INDEX;
extern marcel_t           main_thread;


static marcel_t          *paul;
static p_mad_madeleine_t madeleine;
static MPID_PKT_T        *pkt;
/***********************************************************************************/
/*                                   PROTOTYPES                                    */
/***********************************************************************************/
/*---------------------------------------------------------------------------------*/
MPID_Protocol *MPID_CH_Mad_Eager_setup ( void );
/*---------------------------------------------------------------------------------*/
MPID_Protocol *MPID_CH_Mad_Rndv_setup (void);
/*---------------------------------------------------------------------------------*/
void MPID_Msg_arrived ( int src, 
			int tag, 
			int context_id, 
			MPIR_RHANDLE ** dmpi_recv_handle, 
			int *foundflag );
/*---------------------------------------------------------------------------------*/
int MPID_CH_Abort ( struct MPIR_COMMUNICATOR *,
		    int, 
		    char * );
/*---------------------------------------------------------------------------------*/
void MPID_CH_Mad_Rndv_Handle( p_mad_connection_t connection,
			      MPID_Aint rhandle_address );
/*---------------------------------------------------------------------------------*/
void MPID_CH_Mad_SendCancelOkPacket( void *in_pkt, 
				     int from );
/*---------------------------------------------------------------------------------*/
void MPID_CH_Mad_RecvCancelOkPacket( void *in_pkt, 
			      int from );
/*---------------------------------------------------------------------------------*/
/***********************************************************************************/
/*                                   DEFINITIONS                                   */
/***********************************************************************************/
/*---------------------------------------------------------------------------------*/
void MPID_CH_Mad_Init( int *argc, 
		       char **argv )
{
  p_tbx_slist_t  slist   = NULL; 
  int            index   = 0;
  int            index2  = 0;
  
  common_pre_init (argc, argv, NULL);
  common_post_init(argc, argv, NULL);
  
  main_thread                     = MPID_THREAD_SELF();  
  madeleine                       = mad_get_madeleine();
  MPID_MyWorldSize                = tbx_slist_get_length( madeleine->dir->process_slist );
  MPID_MyWorldRank                = madeleine->session->process_rank;
  slist                           = madeleine->public_channel_slist;           
  MPID_MAD_Global_Channel_Number  = tbx_slist_get_length( slist );
  MPID_MAD_Global_Channel_Table   = (CH_MAD_channel_info_t *)
    MALLOC( MPID_MAD_Global_Channel_Number * sizeof(CH_MAD_channel_info_t));
  MPID_MAD_Channel_Number         = MPID_MAD_Global_Channel_Number;

  if (!tbx_slist_is_nil(slist))                     
    {    
      index =0;
      
      tbx_slist_ref_to_head(slist);               
      do      
	{	  
	  (MPID_MAD_Global_Channel_Table[index]).channel_id  
	    = tbx_slist_ref_get( slist ); 
	  (MPID_MAD_Global_Channel_Table[index]).channel     
	    = tbx_htable_get( madeleine->channel_htable,
			      (MPID_MAD_Global_Channel_Table[index]).channel_id);	  
	  if ( (MPID_MAD_Global_Channel_Table[index]).channel == NULL)
	    {
	      MPID_MAD_Channel_Number--;
	    }
	  index++;
	}
      while (tbx_slist_ref_forward(slist));       
    }
  MPID_CH_Mad_Init_Channel_info( MPID_MAD_Global_Channel_Table , 
				 MPID_MAD_Global_Channel_Number );

  MPID_MAD_Channel_Table = (CH_MAD_channel_info_t *)
    MALLOC( MPID_MAD_Channel_Number * sizeof(CH_MAD_channel_info_t));  
  MPI_USER_COMM          = (MPI_Comm *)MALLOC(MPID_MAD_Channel_Number * sizeof(MPI_Comm)) ;
  for ( index= 0, index2 = 0; index < MPID_MAD_Global_Channel_Number; index++ )
    {
      if ((MPID_MAD_Global_Channel_Table[index]).channel != NULL )
	{
	  MPID_MAD_Channel_Table[index2++] = MPID_MAD_Global_Channel_Table[index] ;
	}
    }
  MPID_CH_Mad_Init_Channel_info( MPID_MAD_Channel_Table ,
				 MPID_MAD_Channel_Number ); 

  MPID_MAD_Default_Channel  = NEW( p_mad_channel_t ); 
  *MPID_MAD_Default_Channel = MPID_CH_Mad_Default_Channel( MPID_MAD_Channel_Table );
  
  for(index = 0 ; index < MPID_MAD_Channel_Number ; index++)
    {
      if (MASTER_OF_CHANNEL((MPID_MAD_Channel_Table[index]).channel))	
	{
	  (MPID_MAD_Channel_Table[index]).master_alive = 
	    (MPID_MAD_CHANNEL_SIZE((MPID_MAD_Channel_Table[index]).channel)) - 1;	
 	}
      else
	{
	  (MPID_MAD_Channel_Table[index]).master_alive = -1; 
	}
      (MPID_MAD_Channel_Table[index]).slave_alive      =  1;
    }
    
  INIT_SYNCRO();  
  
  /*#ifdef GLOBAL_DEBUG  */
  marcel_fprintf(stderr,"========================== Channel Info ================================\n");
  for(index = 0 ; index < MPID_MAD_Channel_Number ; index++)
    {
      marcel_fprintf(stderr,"Channel[%i]  %s \t%i\t%i\t%i\t@%p\t", index , 
		    (MPID_MAD_Channel_Table[index]).channel_id , 
		    (MPID_MAD_Channel_Table[index]).channel_threshold , 
		    (MPID_MAD_Channel_Table[index]).channel_color,
		    (MPID_MAD_CHANNEL_SIZE( (MPID_MAD_Channel_Table[index]).channel )),
	            (MPID_MAD_Channel_Table[index]).channel);
      if (MASTER_OF_CHANNEL( (MPID_MAD_Channel_Table[index]).channel ) )
	{
	  marcel_fprintf(stderr,"Master \n");
	}
      else
	{
	  marcel_fprintf(stderr,"Slave \n");
	}
    }
  marcel_fprintf(stderr,"Default channel is @ %p\n", *MPID_MAD_Default_Channel );
  /*  marcel_printf("size of header is %i bytes\n", SIZE_OF_MADHEADER);  */
  /*#endif  GLOBAL_DEBUG */
  
  paul    = (  marcel_t *)MALLOC( MPID_MAD_Channel_Number * (sizeof (marcel_t)));  
  pkt     = (MPID_PKT_T *)MALLOC( MPID_MAD_Channel_Number * (sizeof (MPID_PKT_T))); 

   /*  profile_activate(FUT_ENABLE, MARCEL_PROF_MASK, 0); */
}
/*---------------------------------------------------------------------------------*/
void mad_end_send ( int dest, 
		    int channel_number, 
		    CH_MAD_MESSAGE_TYPE type )
{
  CH_MAD_HEADER_t     handler __NET_BUFFER__;
  p_mad_connection_t  connection;
  
  handler.type = type;
  /*  LOCK_CHANNEL ( &(MPID_MAD_Channel_Table[channel_number].send_ok) ); */
  connection = mad_begin_packing 
    (MPID_MAD_Channel_Table[channel_number].channel, dest);
  mad_pack (connection, 
	    &handler, 
	    SIZE_OF_MADHEADER,
	    mad_send_CHEAPER, 
	    mad_receive_EXPRESS);
  mad_end_packing (connection);
  /*  UNLOCK_CHANNEL ( &(MPID_MAD_Channel_Table[channel_number].send_ok) ); */
}
/*---------------------------------------------------------------------------------*/
int MPID_CH_End (MPID_Device *dev)
{
   int index, dest , master_of = 0 ,slave_of = 0;
   
   /*   profile_stop(); */ 
  
   for(index = 0 ; index < MPID_MAD_Channel_Number ; index++)
    {
      if ( !MASTER_OF_CHANNEL( (MPID_MAD_Channel_Table[index]).channel ))	
	{
	  mad_end_send( 0 , index , MAD_TERM_PKT );
	  slave_of++;
	}
    }
  
  master_of = MPID_MAD_Channel_Number - slave_of;
  while( master_of )
    {
      for(index = 0 ; index < MPID_MAD_Channel_Number ; index++)
	{
	  if ( MASTER_OF_CHANNEL( (MPID_MAD_Channel_Table[index]).channel ))	
	    {
	      if( (MPID_MAD_Channel_Table[index]).master_alive <= 0)
		{
		  (MPID_MAD_Channel_Table[index]).master_alive = 1;
		  master_of--;
		  
		  for ( dest = 1 ; 
			dest < (MPID_MAD_CHANNEL_SIZE((MPID_MAD_Channel_Table[index]).channel)) ; 
			dest++ )
		    {
		      mad_end_send( dest, index , MAD_TERM_PKT);
		    }
		}
	    }
	}
    }

  while( slave_of )
    {
      for(index = 0 ; index < MPID_MAD_Channel_Number ; index++)
	{
	  if ( !MASTER_OF_CHANNEL( (MPID_MAD_Channel_Table[index]).channel ))	
	    {
	      if( (MPID_MAD_Channel_Table[index]).slave_alive <= 0 )
		{
		  (MPID_MAD_Channel_Table[index]).slave_alive = 1; 
		  slave_of--;
		}
	    }
	}
    }
  
#ifdef MPID_HAS_HETERO	
    MPID_CH_Hetero_free();
#endif /* #HETERO_END# */
  
  (*(dev->short_msg->delete))(dev->short_msg);
  (*(dev->rndv->delete))(dev->rndv);
  
  FREE(dev);
  
#ifdef MPID_FLOW_CONTROL
  MPID_FlowDelete ();
#endif

  /* We should really generate an error or warning message if there 
     are uncompleted operations... */
  
  common_exit(NULL); /* should it be done later ?? */
  return 0;
}
/*---------------------------------------------------------------------------------*/
int MPID_CH_Abort ( struct MPIR_COMMUNICATOR *comm_ptr, 
		    int code, 
		    char *msg )
{
  int dest;
  
  if (msg)
    {
      marcel_fprintf(stderr, "[Node %d] %s\n", MPID_MyWorldRank, msg);
    }
  else
    {
      marcel_fprintf(stderr, 
		     "[Node %d] is aborting program!\n", MPID_MyWorldRank);
    }
  marcel_fflush (stderr);
  marcel_fflush (stdout);
  
  for (dest = 0; dest < MPID_MyWorldSize; dest++)
    {
      if (dest == MPID_MyWorldRank)
	continue;
      else
	{
	  mad_end_send(dest,0,MAD_ABORT_PKT);
	}
    }
  exit(0);
  return 0;
}
/*------------------------------------------------------------------------------*/
/*                    Here lies the core of the whole system                    */
/*------------------------------------------------------------------------------*/
void MPID_CH_Mad_Poll ( poll_args *args )
{
   int             channel_number = (args?:(abort(),args))->channel_number;
   p_mad_channel_t channel        =  args->channel;
#ifdef DEBUG_POLLING
   marcel_t        tid            =  marcel_self();
#endif
   
   BARRIER();
   
#ifdef DEBUG_POLLING     
	marcel_printf("[NODE #%i][THREAD #%i]\t Polling thread running ...\n",
		      MPID_MyWorldRank,tid->number);
	marcel_delay(5000);
#endif  
   
   while( FOR_EVER )
     {
	p_mad_connection_t connection;
	CH_MAD_HEADER_t    header __NET_BUFFER__;
	
#ifdef DEBUG_POLLING 
	marcel_printf("[NODE #%i][THREAD #%i]\t Polling thread Waiting for External message ...\n",
		      MPID_MyWorldRank,tid->number);
#endif 
	
#ifdef MAD_MESSAGE_POLLING
	connection = mad_message_ready(channel); 
	if (connection == NO_CONNECTION)
	  {
	     marcel_yield();
	  }
	else
	  {
#else /* MAD_MESSAGE_POLLING */
	     connection = mad_begin_unpacking(channel); 	  
#endif /* MAD_MESSAGE_POLLING */
	     
#ifdef DEBUG_POLLING
	     marcel_printf("[NODE #%i][THREAD #%i]\t Polling thread ready to get data\n",
			   MPID_MyWorldRank,tid->number);
#endif 
	     mad_unpack (connection, 
			 &header, 
			 SIZE_OF_MADHEADER, 
			 mad_send_CHEAPER,
			 mad_receive_EXPRESS);

#ifdef DEBUG_POLLING
	     marcel_printf("[NODE #%i][THREAD #%i]\t MAD_HEADER received =========> ",
			   MPID_MyWorldRank,tid->number);
#endif
	     switch(header.type)
	       {
		case MAD_RNDV_PKT:
		    {
#ifdef DEBUG_POLLING	
		       marcel_printf(" of type RNDV_PKT from [NODE #%i][THREAD #%i]\n",
				     header.node_id, header.tid);
#endif
		       MPID_CH_Mad_Rndv_Handle( connection,
						header.opt_field.rhandle_address );
		    }
		  break;

		case MAD_REQUEST_PKT:
		case MAD_SENDOK_PKT:
		case MAD_CANCEL_PKT:  
		case MAD_SHORT_PKT:
		    {
		       MPID_Device  *dev        = args->device;
		       MPIR_RHANDLE *rhandle    = NULL;
		       int          err         = MPI_SUCCESS;
		       int          from_grank;
		       int          is_posted;
		       
		       switch(header.type)
			 {
			  case MAD_SHORT_PKT:
			    args->pkt.head = header.opt_field.head_pkt;
#ifdef DEBUG_POLLING	
			    marcel_printf(" of type SHORT_PKT from [NODE #%i][THREAD #%i]\n",
					  header.node_id, header.tid);
#endif
			    break;
			    
			  case MAD_REQUEST_PKT:
			    args->pkt.request_pkt = header.opt_field.request_pkt;
			    mad_end_unpacking(connection);
#ifdef DEBUG_POLLING
			    marcel_printf(" of type REQUEST_PKT from [NODE #%i][THREAD #%i]\n",
					  header.node_id, header.tid);
#endif
			    break;
			    
			  case MAD_SENDOK_PKT:
			    args->pkt.sendok_pkt = header.opt_field.sendok_pkt;
			    mad_end_unpacking(connection);
#ifdef DEBUG_POLLING	    
			    marcel_printf(" of type SENDOK_PKT from [NODE #%i][THREAD #%i]\n",
					  header.node_id, header.tid);
#endif
			    break;
			    
			  case MAD_CANCEL_PKT:
			    args->pkt.antisend_pkt = header.opt_field.antisend_pkt;
			    mad_end_unpacking(connection);
#ifdef DEBUG_POLLING	    
			    marcel_printf(" of type CANCEL_PKT from [NODE #%i][THREAD #%i]\n",
					  header.node_id, header.tid);
#endif
			    break;
			    
			  default:
			    marcel_fprintf(stderr, "[%d] Internal error: msg packet discarded (%s:%d)\n",
					   MPID_MyWorldRank, __FILE__, __LINE__);
			    marcel_fflush(stderr);
			    mad_end_unpacking (connection);
			 }
		       
		       from_grank = args->pkt.head.src;
		       
		       /* seulement dfini si MPID_HAS_HETERO l'est */
		       MPID_PKT_UNPACK(&args->pkt, sizeof (MPID_PKT_HEAD_T), from_grank);
		       
		       /* Separate the incoming messages from control messages */
		       if(MPID_PKT_IS_MSG(args->pkt.head.mode))
			 {
			    /* Is the message expected or not? 
			     This routine RETURNS a rhandle, creating one if the message 
			     is unexpected (is_posted == 0) */
#ifdef DEBUG_POLLING	    
			    marcel_printf("[NODE #%i][THREAD #%i]\t Checking message queue .... ",
					  MPID_MyWorldRank,tid->number);
#endif
			    MPID_Msg_arrived( args->pkt.head.lrank,
					      args->pkt.head.tag,
					      args->pkt.head.context_id,
					      &rhandle, 
					      &is_posted );
			    
			    MPID_DO_HETERO( rhandle->msgrep = 
					    (MPID_Msgrep_t)(args->pkt.head.msgrep));
#ifdef DEBUG_POLLING
			    marcel_printf("Done !\n");
#endif
			    if (is_posted)
			      {		
				 /* We should check the size here for internal errors .... */
				 switch ( args->pkt.head.mode )
				   {
				      
				    case MPID_PKT_SHORT:
					{
					   CH_MAD_SHORT_ARGS myargs; 
					   myargs.connection = connection; 
					   myargs.pkt        = &(args->pkt.short_pkt);
#ifdef OPT
					   myargs.buffer     = header.padding;
#endif 
#ifdef DEBUG_POLLING		      
					   marcel_printf("[NODE #%i][THREAD #%i]\t ADI SHORT pkt is  ==> expected\n",
							 MPID_MyWorldRank,tid->number);
#endif      			      
					   err = (*(dev->short_msg->recv)) ( rhandle, 
									     from_grank, 
									     &myargs); 
					   break;
					}
				    case MPID_PKT_REQUEST_SEND:
#ifdef DEBUG_POLLING
				      marcel_printf("[NODE #%i][THREAD #%i]\t ADI REQUEST SEND  pkt is  ==> expected\n",
						    MPID_MyWorldRank,tid->number);
				      marcel_printf("[NODE #%i][THREAD #%i]\t ============> RHANDLE @ is %p\n",
						    MPID_MyWorldRank,tid->number, rhandle);
#endif
				      err = (*(dev->rndv->irecv)) ( rhandle, 
								    from_grank,
								    &args->pkt,
								    channel);
				      break;
				      
				    default:
				      marcel_fprintf (stderr,
						      "[%d] Internal error: msg packet discarded (%s:%d)\n",
						      MPID_MyWorldRank, __FILE__, __LINE__);
				      marcel_fflush (stderr);
				   }
			      }
			    else
			      {
				 switch (args->pkt.head.mode)
				   {
				    case MPID_PKT_SHORT:
					{
					   CH_MAD_SHORT_ARGS myargs;
					   int               msglen = header.opt_field.head_pkt.len;
					   myargs.pkt               = &(args->pkt.short_pkt);
					   /* myargs.fast_buffer    = args->fast_buffer;  */
					   myargs.buffer            = NULL;  
#ifdef OPT
					   if( ( msglen > 0) && ( msglen <= OPT_BUF_SIZE ))
					     {
						myargs.buffer = MALLOC( msglen );
						MEMCPY( myargs.buffer, header.padding ,msglen);
					     }
					   
					   else 
#else /* OPT */
					   if(msglen > 0)
#endif /* OPT */
					     {
#ifdef ENFORCE_ALIGNMENT
						int _msglen = tbx_aligned( msglen, MAD_LENGTH_ALIGNMENT );
#else /* ENFORCE_ALIGNMENT */      
						int _msglen = msglen;
#endif /* ENFORCE_ALIGNMENT */    
						myargs.buffer = MALLOC( _msglen );
						/*tbx_malloc( args->fast_buffer ); */
						
						mad_unpack ( connection, 
							     myargs.buffer,
							     _msglen, 
							     mad_send_CHEAPER,
							     mad_receive_CHEAPER); 
					     }					   
					   mad_end_unpacking( connection );
#ifdef DEBUG_POLLING		      
					   marcel_printf("[NODE #%i][THREAD #%i]\t ADI SHORT pkt is  ==> UNEXpected\n",
							 MPID_MyWorldRank,tid->number);
#endif
					   OUTPUT("Received an UNEXpected  MPID_PKT_SHORT ADI Packet");
					   err = (*(dev->short_msg->unex)) ( rhandle, 
									     from_grank, 
									     &myargs,
									     channel);
					}
				      break;
				      				      
				    case MPID_PKT_REQUEST_SEND:
#ifdef DEBUG_POLLING
				      marcel_printf("[NODE #%i][THREAD #%i]\t ADI REQUEST SEND  pkt is  ==> UNEXpected\n",
						    MPID_MyWorldRank,tid->number);
#endif    
				      err = (*(dev->rndv->unex)) (rhandle, 
								  from_grank, 
								  &args->pkt,
								  channel);
				      break;
				      
				    default:
				      marcel_fprintf (stderr,
						      "[%d] Internal error: msg packet discarded (%s:%d)\n",
						      MPID_MyWorldRank, __FILE__, __LINE__);
				   }
			      }
			 }
		       else
			 {
			    switch (args->pkt.head.mode)
			      {
			       case MPID_PKT_OK_TO_SEND:
#ifdef DEBUG_POLLING
				 marcel_printf("[NODE #%i][THREAD #%i]\t Received an OK_TO_SEND pkt from [NODE #%i][THREAD #%i]\n",
					       MPID_MyWorldRank,tid->number,header.node_id, header.tid); 
#endif
				 err = (*(dev->rndv->do_ack)) (&args->pkt, 
							       from_grank,
							       channel);
				 break;
				 
			       case MPID_PKT_ANTI_SEND:
#ifdef DEBUG_POLLING
				 marcel_printf("[NODE #%i][THREAD #%i]\t Received an ANTI_SEND pkt from [NODE #%i][THREAD #%i]\n", 
					       MPID_MyWorldRank,tid->number,header.node_id, header.tid); 
#endif
				 MPID_CH_Mad_SendCancelOkPacket( &args->pkt, 
								 from_grank);
				 break;
				 
			       case MPID_PKT_ANTI_SEND_OK:
#ifdef DEBUG_POLLING
				 marcel_printf("[NODE #%i][THREAD #%i]\t Received an ANTI_SEND_OK pkt from [NODE #%i][THREAD #%i]\n", 
					       MPID_MyWorldRank,tid->number,header.node_id, header.tid); 
#endif
				 MPID_CH_Mad_RecvCancelOkPacket( &args->pkt, 
						    from_grank);
				 break;
				 
#ifdef MPID_FLOW_CONTROL
			       case MPID_FLOW_CONTROL:
				 MPID_RecvFlowPacket (&args->pkt, from_grank);
				 break;
#endif
			       default:
				 marcel_fprintf (stdout, "[%d] Mode %d is unknown (internal error) %s:%d!\n",
						 MPID_MyWorldRank, args->pkt.head.mode, __FILE__, __LINE__);
			      }
			    /* Really should remember error in case subsequent events are successful */
			 }
		    }
		  break;
		  
		case MAD_ABORT_PKT: 
		  exit(0); 
		  break;
		  
		case MAD_TERM_PKT:
		  mad_end_unpacking ( connection );
		  if ( (MASTER_OF_CHANNEL( channel )) )
		    {
		       if (--((MPID_MAD_Channel_Table[channel_number]).master_alive)  <= 0)
			 {
			    marcel_exit(0);
			 }
		    }
		  else
		    {
		       (MPID_MAD_Channel_Table[channel_number]).slave_alive-- ;
		       marcel_exit(0); 	  
		    }
		  break;
		  
		default:
		  marcel_fprintf(stderr, 
				 "[Node %i][Channel %i]:\t 
				   Message Error\t (%s: line %d)\n",
				 MPID_MyWorldRank, 
				 channel_number, __FILE__, __LINE__);
		  marcel_fprintf(stderr, 
				 "[Node %i][Channel %i]: header type is : %i\n",
				 MPID_MyWorldRank, 
				 channel_number, header.type);
		  marcel_fflush(stderr);
		  MPID_CH_Abort((struct MPIR_COMMUNICATOR *)0,
				888,"Polling thread aborting ... \n");
	       }
#ifdef MAD_MESSAGE_POLLING
	  }
#endif
     }
}
/*-----------------------------------------------------------------------------*/
MPID_Device *MPID_CH_InitMsgPass ( int *argc, 
				   char ***my_argv, 
				   int short_len, 
				   int long_len )
{
   MPID_Device    *dev = NEW( MPID_Device );
   /* p_tbx_memory_t *buffer_list; */
   /* buffer_list = (p_tbx_memory_t *)MALLOC(net_number * 
    (sizeof (p_tbx_memory_t))); */
   marcel_attr_t attributes;
   
   if (!dev)
     {
	return NULL;
     }
   
   if (short_len < 0)
     {
	short_len = DEFAULT_TYPE_SWITCH;
     }
   if (long_len < 0)
     {
	long_len = short_len;
     }
   
   dev->long_len      = short_len;
   dev->vlong_len     = long_len;
   dev->channel_table = MPID_MAD_Channel_Table;
   dev->short_msg     = MPID_CH_Mad_Eager_setup(); 
   dev->long_msg      = dev->short_msg;
   dev->vlong_msg     = MPID_CH_Mad_Rndv_setup();   
   dev->eager         = dev->short_msg; 
   dev->rndv          = dev->vlong_msg; 
   dev->check_device  = NULL; 
   dev->terminate     = MPID_CH_End;
   dev->abort         = MPID_CH_Abort;
   dev->next          = NULL;
   
   MPID_DO_HETERO (MPID_CH_Init_hetero (argc, my_argv));
#ifdef MPID_FLOW_CONTROL
   /* Try to get values for thresholds.  Note that everyone MUST have
    the same values for this to work */
     {
	int buf_thresh = 0, mem_thresh = 0;
	char *val;
	val = getenv ("MPI_BUF_THRESH");
	if (val)
	  buf_thresh = atoi (val);
	val = getenv ("MPI_MEM_THRESH");
	if (val)
	  mem_thresh = atoi (val);
	MPID_FlowSetup (buf_thresh, mem_thresh);
     }
#endif
   
   if (MPID_MyWorldSize > 1)
     {
	int index;
	marcel_attr_init(&attributes);	
	marcel_attr_setdetachstate(&attributes, TRUE);
	for (index = 0; index < MPID_MAD_Channel_Number ; index++)
	  {
	     poll_args  *args = NEW( poll_args );
	     
	     /* tbx_malloc_init( &(buffer_list[index]),   */
	     /* 			   MPID_PKT_MAX_DATA_SIZE,    */
	     /* 			    BUFFER_NUMBER);   */
	     /* args->fast_buffer    = buffer_list[index] ; */
	     /*  args                 = NEW( poll_args );*/
	     
	     args->device         = dev;
	     args->channel_number = index;	  
	     args->channel        = MPID_MAD_Channel_Table[index].channel;
	     args->pkt            = pkt[index]; 

	     marcel_create (&paul[index],&attributes,
			    (marcel_func_t) MPID_CH_Mad_Poll, args);
	  }
     }
   return dev;
}
/**********************************************************************/








