#ifndef MPIREQALLOC
#define MPIREQALLOC

/* Allocation of handles */
#include "sbcnst2.h"
#include "ptrcvt.h"
/* lock and syncro mechanisms */
#include "syncro.h" 


/* Because we may need to provide integer index values for the handles
   in converting to/from Fortran, we provide a spot for a separate index
   free operation 

   If you initialize anything, also check the MPID_Request_init macro in
   req.h
 */

extern MPID_SBHeader MPIR_shandles;
extern MPID_SBHeader MPIR_rhandles;

#ifdef GLOBAL_DEBUG
#define MPID_LocalFree( a ) { if (((MPIR_COMMON *)(a))->self_index) { \
                                  marcel_printf("---> REmoving pointer \n"); \
                                  MPIR_RmPointer(((MPIR_COMMON *)(a))->self_index); \
				  marcel_printf("---> Done\n"); \
			        } \
			      marcel_printf("---> Freeing struct syncro \n"); \
                              MPID_HANDLE_SSYNCRO_FREE( a ); \
                              marcel_printf("---> Done\n");}
#else /* GLOBAL_DEBUG */
#define MPID_LocalFree( a ) { if (((MPIR_COMMON *)(a))->self_index) { \
                                  MPIR_RmPointer(((MPIR_COMMON *)(a))->self_index); \
			        } \
			      MPID_HANDLE_SSYNCRO_FREE( a );} 

#endif /* GLOBAL_DEBUG */

/* These four are used to initialize a structure that is allocated
   off of the stack */
#define MPID_RecvInit( a ) { memset((a),0,sizeof(*(a))); MPID_HANDLE_SSYNCRO_INIT( a ) } 
#define MPID_PRecvInit( a ) { memset((a),0,sizeof(*(a))); MPID_HANDLE_SSYNCRO_INIT( a ) }
#define MPID_SendInit( a ) { memset((a),0,sizeof(*(a))); MPID_HANDLE_SSYNCRO_INIT( a ) }
#define MPID_PSendInit( a ) { memset((a),0,sizeof(*(a))); MPID_HANDLE_SSYNCRO_INIT( a ) }

#ifdef MPIR_MEMDEBUG 
#define MPID_RecvAlloc( a ) (a)=NEW( MPIR_RHANDLE )
#define MPID_SendAlloc( a ) (a)=NEW( MPIR_SHANDLE )
#define MPID_PRecvAlloc( a ) (a)=NEW( MPIR_PRHANDLE )
#define MPID_PSendAlloc( a ) (a)=NEW( MPIR_PSHANDLE )
 
#define MPID_RecvFree( a )  {MPID_HANDLE_WAIT4USED( a ); MPID_LocalFree( a ); FREE( a );}
#define MPID_SendFree( a )  {MPID_HANDLE_WAIT4USED( a ); MPID_LocalFree( a ); FREE( a );}
#define MPID_PRecvFree( a ) {MPID_HANDLE_WAIT4USED( a ); MPID_LocalFree( a ); FREE( a );}
#define MPID_PSendFree( a ) {MPID_HANDLE_WAIT4USED( a ); MPID_LocalFree( a ); FREE( a );}
#else /* MPIR_MEMDEBUG */
#define MPID_RecvAlloc( a )  (a)=(MPIR_RHANDLE *)MPID_SBalloc( MPIR_rhandles )
#define MPID_SendAlloc( a )  (a)=(MPIR_SHANDLE *)MPID_SBalloc( MPIR_shandles )
#define MPID_PRecvAlloc( a ) (a)=(MPIR_PRHANDLE *)MPID_SBalloc( MPIR_rhandles )
#define MPID_PSendAlloc( a ) (a)=(MPIR_PSHANDLE *)MPID_SBalloc( MPIR_shandles )

#define MPID_RecvFree( a ) { MPID_HANDLE_WAIT4USED( a ); \
			     MPID_LocalFree( a ); \
                             MPID_SBfree( MPIR_rhandles, a );}

#define MPID_SendFree( a ) { MPID_HANDLE_WAIT4USED( a ); \
                             MPID_LocalFree( a ); \
			     MPID_SBfree( MPIR_shandles, a );}

#define MPID_PRecvFree( a ) { MPID_HANDLE_WAIT4USED( a ); \
                              MPID_LocalFree( a ); \
			      MPID_SBfree( MPIR_rhandles, a );}

#define MPID_PSendFree( a ) { MPID_HANDLE_WAIT4USED( a ); \
                              MPID_LocalFree( a ); \
			      MPID_SBfree( MPIR_shandles, a );}
#endif /* MPIR_MEMDEBUG */


#endif /* MPIREQALLOC */




















