/*
 *  $Id: sbcnst2.h,v 1.1.1.1 2003/07/30 15:35:47 lprylli Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#ifndef _SBCNST
#define _SBCNST

#if defined(HAVE_MPICHCONF_H) && !defined(MPICHCONF_INC)
/* This includes the definitions found by configure, and can be found in
   the library directory (lib/$ARCH/$COMM) corresponding to this configuration
 */
#define MPICHCONF_INC
#include "mpichconf.h"
#endif

#include <stdio.h>

typedef struct _MPID_SBHeader *MPID_SBHeader;
extern MPID_SBHeader MPID_SBinit ( int, int, int );
extern void  MPID_SBfree ( MPID_SBHeader, void * ),
            *MPID_SBalloc ( MPID_SBHeader ),
             MPID_SBPrealloc ( MPID_SBHeader, int ),
             MPID_SBdestroy ( MPID_SBHeader ),
             MPID_SBrelease ( MPID_SBHeader, void * ),
             MPID_SBFlush ( MPID_SBHeader ),
             MPID_SBDump ( FILE *, MPID_SBHeader ),
             MPID_SBReleaseAvail ( MPID_SBHeader ),
             MPID_SBvalid ( MPID_SBHeader );

/* Chameleon/PETSc includes memory tracing functions that can be used
   to track storage leaks.  This code chooses that or the copy that 
   has been placed into mpich/util/tr.c 
 */
#ifndef MALLOC

#if defined(MPIR_MEMDEBUG)
/* Use MPI tr version of MALLOC/FREE */
#include "tr2.h"
/* Also replace the SB allocators so that we can get the trmalloc line/file
   tracing. */
#define MPID_SBinit(a,b,c) ((void *)(a))
#define MPID_SBalloc(a)    MPID_trmalloc((unsigned)(a),__LINE__,__FILE__)
#define MPID_SBfree(a,b)   MPID_trfree((char *)(b),__LINE__,__FILE__)
#define MPID_SBdestroy(a)
#else /* MPIR_MEMDEBUG*/

/* We also need to DECLARE malloc etc here.  Note that P4 also declares
   some of these, and thus if P4 in including this file, we skip these
   declarations ... */
#ifndef P4_INCLUDED

#if HAVE_STDLIB_H || STDC_HEADERS
#include <stdlib.h>

#else
#ifdef __STDC__
extern void 	*calloc(/*size_t, size_t*/);
extern void	free(/*void * */);
extern void	*malloc(/*size_t*/);
#elif defined(MALLOC_RET_VOID)
extern void *malloc();
extern void *calloc();
#else
extern char *malloc();
extern char *calloc();
/* extern int free(); */
#endif /* __STDC__ */
#endif /* HAVE_STDLIB_H || STDC_HEADERS */
#endif /* !defined(P4_INCLUDED) */

/********* Modif GM *********************/
#include "pm2_common.h"
void *trace_malloc(unsigned int size);

#define MALLOC(a) tbx_aligned_malloc((a), MAD_ALIGNMENT)
/* #define MALLOC(a)   trace_malloc( a ) ; marcel_fprintf(stderr," ===========> Malloc Position ( %s @ line %i)\n", \ */
/* 						       __FILE__,__LINE__)  */

#define CALLOC(a,b)  TBX_CALLOC((unsigned)(a),(unsigned)(b)) 
#define REALLOC(a,b) TBX_REALLOC((void *) a, (unsigned) b) 


#define FREE(a) tbx_aligned_free((a), MAD_ALIGNMENT)

/* #define FREE(a)        { marcel_fprintf(stderr,"===========> Entering Free ( %s @ l%i)\n", __FILE__,__LINE__); \ */
/*                          tbx_aligned_free((a), MAD_ALIGNMENT); \ */
/* 		         marcel_fprintf(stderr,"<=========== Exiting  Free \n");} */

#define __NET_BUFFER__  __attribute__ ((aligned (MAD_ALIGNMENT)))

/***************************************/

#define NEW(a)    (a *)MALLOC(sizeof(a))
#ifndef STRDUP
#define STRDUP(a)    strdup(a)
#endif

#endif /*MPIR_MEMDEBUG*/
#endif /*MALLOC*/

#endif









