#ifndef CPTHREADS_H
#define CPTHREADS_H

#include <marcel.h>

#include <converse.h>
/* for size_t */
#include <sys/types.h>

#define CPTHREAD_THREADS_MAX     1000000000
#define CPTHREAD_KEYS_MAX        1000000000
#define CPTHREAD_STACK_MIN       32768
#define CPTHREAD_CREATE_DETACHED 1
#define CPTHREAD_CREATE_JOINABLE 0

#define Cpthread_once_t                  marcel_once_t
#define Cpthread_attr_t                  marcel_attr_t
#define Cpthread_key_t                   marcel_key_t
#define Cpthread_cleanup_t               marcel_cleanup_t
#define Cpthread_mutexattr_t             marcel_mutexattr_t
#define Cpthread_condattr_t              marcel_condattr_t
#define Cpthread_mutex_t                 marcel_mutex_t
#define Cpthread_cond_t                  marcel_cond_t
#define Cpthread_t                       marcel_t
#define Cpthread_attr_init               marcel_attr_init
#define Cpthread_attr_destroy            marcel_attr_destroy
#define Cpthread_attr_getstacksize       marcel_attr_getstacksize
#define Cpthread_attr_setstacksize       marcel_attr_setstacksize
#define Cpthread_attr_getdetachstate     marcel_attr_getdetachstate
#define Cpthread_attr_setdetachstate     marcel_attr_setdetachstate
#define Cpthread_key_create              marcel_key_create
#define Cpthread_key_delete              marcel_key_delete
#define Cpthread_setspecific             marcel_setspecific
#define Cpthread_getspecific             marcel_getspecific
#define Cpthread_cleanup_push            marcel_cleanup_push
#define Cpthread_cleanup_pop             marcel_cleanup_pop
#define Cpthread_exit                    marcel_exit
#define Cpthread_top                     marcel_top
#define Cpthread_create                  marcel_create
#define Cpthread_equal                   marcel_equal
#define Cpthread_self                    marcel_self
#define Cpthread_detach                  marcel_detach
#define Cpthread_join                    marcel_join
#define Cpthread_mutexattr_init          marcel_mutexattr_init
#define Cpthread_mutexattr_destroy       marcel_mutexattr_destroy
#define Cpthread_mutexattr_getpshared    marcel_mutexattr_getpshared
#define Cpthread_mutexattr_setpshared    marcel_mutexattr_setpshared
#define Cpthread_mutex_init              marcel_mutex_init
#define Cpthread_mutex_destroy           marcel_mutex_destroy
#define Cpthread_mutex_lock              marcel_mutex_lock
#define Cpthread_mutex_trylock           marcel_mutex_trylock
#define Cpthread_mutex_unlock            marcel_mutex_unlock
#define Cpthread_condattr_init           marcel_condattr_init
#define Cpthread_condattr_destroy        marcel_condattr_destroy
#define Cpthread_condattr_getpshared     marcel_condattr_getpshared
#define Cpthread_condattr_setpshared     marcel_condattr_setpshared
#define Cpthread_cond_init               marcel_cond_init
#define Cpthread_cond_destroy            marcel_cond_destroy
#define Cpthread_cond_wait               marcel_cond_wait
#define Cpthread_cond_signal             marcel_cond_signal
#define Cpthread_cond_broadcast          marcel_cond_broadcast
#define Cpthread_once                    marcel_once
#define Cpthread_init                    marcel_init

#define Cpthread_yield                   marcel_yield

#endif /* CPTHREADS_H */
